## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## sdEventManager by Stone-D (Laga Mahesa)
## Copyright Laga Mahesa 2005
##
## Version StackXP 1.10


############## EVENT MANAGER GLOBALS ################
from CvPythonExtensions import *
import CvUtil
import PyHelpers
import Popup as PyPopup
import sys

gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

import CvEventManager

################# SD-UTILITY-PACK ###################
import sdToolKit
sdEcho        = sdToolKit.sdEcho

################# STONE-D GLOBALS ###################
# import sdReligion
# import sdCultureConquest
import sdStackXP

################ 3RD PARTY GLOBALS ##################
# <Inquisition>
# import Inquisition
# </Inquisition>

# <cultureDecay>
# import CulturalDecay
# </cultureDecay>

# <TechConquest>
# import TechConquest
# </TechConquest>

# <SettlerReligion>
# import SettlerReligion
# </SettlerReligion>

# <AbandonRazeDemolish>
# import AbandonRazeDemolish
# raze = AbandonRazeDemolish.AbandonRazeDemolish()
# </AbandonRazeDemolish>

############## EVENTMANAGER SUBCLASS ################
class sdEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

#		self.sdReligion        = sdReligion.sdReligion()
#		self.sdCultureConquest = sdCultureConquest.sdCultureConquest()
		self.sdStackXP         = sdStackXP.sdStackXP()
#		self.Inquisition       = Inquisition.Inquisition()
#		self.CulturalDecay     = CulturalDecay.CulturalDecay()
#		self.TechConquest      = TechConquest.TechConquest()
#		self.SettlerReligion   = SettlerReligion.SettlerReligion()

		# <AbandonRazeDemolish>
#		self.Events[7500] = ('DestroyBuildingPopup', self.__eventDestroyBuildingApply , self.__eventDestroyBuildingBegin)
		# </AbandonRazeDemolish>

################ EVENT DEFINITIONS ##################
	def onBuildingBuilt(self, argsList):
		# <Inquisition>
#		self.Inquisition.BuildInquisition(argsList)
		# </Inquisition>
		self.parent.onBuildingBuilt(self, argsList)

	def onCityAcquired(self, argsList):
		# <sdCultureConquest>
#		self.sdCultureConquest.sdCultureConquestCityAcquired(argsList)
		# </sdCultureConquest>
		# <TechConquest>
#		self.TechConquest.TechConquest(argsList)
		# </TechConquest>
		self.parent.onCityAcquired(self, argsList)

	def onCityBuilt(self, argsList):
		# <sdCultureConquest>
#		self.sdCultureConquest.sdCultureConquestCityBuilt(argsList)
		# </sdCultureConquest>
		# <SettlerReligion>
#		self.SettlerReligion.onCityBuilt(argsList)
		# </SettlerReligion>
		self.parent.onCityBuilt(self, argsList)

	def onCityRazed(self, argsList):
		# <sdCultureConquest>
#		self.sdCultureConquest.sdCultureConquestCityRazed(argsList)
		# </sdCultureConquest>
		# <AbandonRazeDemolish>
#		raze.onCityRazed(argsList)
		# </AbandonRazeDemolish>
		self.parent.onCityRazed(self, argsList)

	def onCombatResult(self, argsList):
		# <sdStackXP>
		self.sdStackXP.sdStackXPCombatResult(argsList)
		# </sdStackXP>
		self.parent.onCombatResult(self, argsList)

	def onEndGameTurn(self, argsList):
		# <sdCultureConquest>
#		self.sdCultureConquest.sdCultureConquestEndGameTurn()
		# </sdCultureConquest>
		# <sdStackXP>
		self.sdStackXP.sdStackXPDoVersionCheck()
		# </sdStackXP>
		# <cultureDecay>
#		self.CulturalDecay.onEndGameTurn(argsList)
		# </cultureDecay>
		self.parent.onEndGameTurn(self, argsList)

	def onKbdEvent(self, argsList):
		# <AbandonRazeDemolish>
#		if (raze.onKbdEvent(argsList, self.bCtrl) == 1):
#			self.beginEvent(7500)
#			return 1
		# </AbandonRazeDemolish>
		self.parent.onKbdEvent(self, argsList)

	def onReligionFounded(self, argsList):
		# <sdReligion>
#		self.sdReligion.sdReligionDistributeTechs(argsList)
		# </sdReligion>
		self.parent.onReligionFounded(self, argsList)

	def onReligionSpread(self, argsList):
		# <sdReligion>
#		self.sdReligion.sdReligionHolyCityCheck(argsList)
		# </sdReligion>
		self.parent.onReligionSpread(self, argsList)

	def onUnitBuilt(self, argsList):
		# <sdStackXP>
		self.sdStackXP.sdStackXPInitUnit(argsList[1])
		# </sdStackXP>
		# <SettlerReligion>
#		self.SettlerReligion.onUnitBuilt(argsList)
		# </SettlerReligion>
		self.parent.onUnitBuilt(self, argsList)

	def onUnitLost(self, argsList):
		# <sdStackXP>
		self.sdStackXP.sdStackXPWipeUnit(argsList[0])
		# </sdStackXP>
		# <SettlerReligion>
#		self.SettlerReligion.onUnitLost(argsList)
		# </SettlerReligion>
		self.parent.onUnitLost(self, argsList)

############## 3RD PARTY DEFINITIONS ################

	# <AbandonRazeDemolish>
#	def __eventDestroyBuildingApply(self, playerID, userData, popupReturn):
#		raze.eventDestroyBuildingApply(playerID, userData, popupReturn)
		
#	def __eventDestroyBuildingBegin(self, argsList):
#		raze.eventDestroyBuildingBegin(argsList)
	# </AbandonRazeDemolish>

#################### TRIGGERED EVENTS ##################
